#!/tvbin/tivosh
#
#                 AdjustTimeZone30 v0.9  for Tivo 3.0
#
# WARNING
#     AdjustTimeZone30 is provided as-is without warranty or guarantee.
#     The author(s) assume no liability for any personal or property
#     damage that may occur from any activity involving AdjustTimeZone30
#     such as the process of a) preparing your Tivo for the
#     installation of AdjustTimeZone30 or similar programs, b) installing
#     AdjustTimeZone30 into your Tivo receiver, or c) running AdjustTimeZone30
#                                                          
# Overview
#     AdjustTimeZone30 displays time zone codes, asks for a timezone code and
#     sets Tivo on that timezone. The program guide times and Tivo time are
#     adjusted automatically based on the time zone.
# 
# Compatibility
#     AdjustTimeZone30 runs well on my Tivo since sep 8, 2002 on
#     Series I (SA-US-NTSC), Philips , hacked second disk, 
#     OS 3.0-01-1-000, running in PAL mode (bootparm TV_STD=PAL)
#
# Copying
#     Feel free to copy,distribute,post,modify, and/or improve AdjustTimeZone30
#     Version control in header apreciated
#
# Credits
#     The AdjustTimeZone30 DB-core is based on Adjust Time Zone - 2.5.1 by
#     Andrew Palm.  Thanks. That script run on 2.5 -  AdjustTimeZone30
#     runs on Tivo 3.0  
#
# Known bugs and issues
#     - Did test timezone 8 and 4, have not tested other timezone codes.
#     - The 2.5 version included code to set daylight savings policy, did
#       not implement that on 3.0
#     - I use the bootparm TV_STD=PAL to run my US-SA unit in PAL mode and 
#       and have to 'export TV_STD=NTSC' from bash (without quotes) before
#       I run AdjustTimeZone30 , and reset that afterwards: export TV_STD=PAL
#       Dont know whether that reset has side effects. Restart afterwards is
#       the safe way to go
#

source /tvlib/tcl/tv/DbEnum.tcl

    puts "Hawaii ${TimeZone::Hawaii}"
    puts "Alaska ${TimeZone::Alaska}"
    puts "Pacific ${TimeZone::Pacific}"
    puts "Mountain ${TimeZone::Mountain}"
    puts "Central ${TimeZone::Central}"
    puts "Eastern ${TimeZone::Eastern}"
    puts "GMT-1 ${TimeZone::GMTMinus1}"
    puts "GMT-11 ${TimeZone::GMTMinus11}"
    puts "GMT-12 ${TimeZone::GMTMinus12}"
    puts "GMT-2 ${TimeZone::GMTMinus2}"
    puts "GMT-3 ${TimeZone::GMTMinus3}"
    puts "GMT-4 ${TimeZone::GMTMinus4}"
    puts "GMT+2 ${TimeZone::GMTPlus2}"
    puts "GMT+3 ${TimeZone::GMTPlus3}"
    puts "GMT+4 ${TimeZone::GMTPlus4}"
    puts "GMT+5 ${TimeZone::GMTPlus5}"
    puts "GMT+6 ${TimeZone::GMTPlus6}"
    puts "GMT+7 ${TimeZone::GMTPlus7}"
    puts "GMT+8 ${TimeZone::GMTPlus8}"
    puts "GMT+9 ${TimeZone::GMTPlus9}"
    puts "GMT ${TimeZone::GMT}"
    puts "GMT+1 (w-Europe) ${TimeZone::GMTPlus1}"
    puts "GMT+10 ${TimeZone::GMTPlus10}"
    puts "GMT+11 ${TimeZone::GMTPlus11}"
    puts "GMT+12 ${TimeZone::GMTPlus12}"

# get new time zone, adjust if not blank or not -
puts "Enter new Time Zone (- if no change, have to restart Tivo afterwards)"
gets stdin tzNew
if { $tzNew != "-" && $tzNew != ""   } {

  set db [dbopen]
  RetryTransaction {
    # get the locationconfig object, then timezone
    set config [db $db open /State/LocationConfig]
    set tzOld [dbobj $config get TimeZoneOld]
    # set new timezone, get-to-check and display new
    dbobj $config set TimeZoneOld $tzNew
    set tzNew [dbobj $config get TimeZoneOld]
    puts "Timezone was $tzOld now set to $tzNew"

    # From 2.5 , don't know how to and why to set policy in 3.0
      dbobj $config set DaylightSavingsPolicy 0

  }
  dbclose $db
  unset db
# See /tvlib/tcl/tv/Inc.itcl for a list of these enums.
  event send $TmkEvent::EVT_DATA_CHANGED $TmkDataChanged::RECORDINGS_ON_DISK 0
  puts "Done, please restart Tivo."
}

